#include "thermonew.h"

// MAKE SURE lines are < 120 chars and end with newline, or buffer overflow!
// prog_char changed to const char after Arduino IDE v 1.5.8 or so.
const char vactmpl[] PROGMEM = "<tr>\n"
"<th colspan=2>Vacation remaining</th><td>_VTIME minutes</td>\n"
"<td><A HREF=\"/v0Aardv4rk*ch33se\">Clear</A></td>\n"
"</tr>\n"
"<tr>\n"
"<th colspan=2>Add vacation time</th>\n"
"<td><A HREF=\"/V20160Aardv4rk*ch33se\">Two Weeks</A></td>\n"
"<td><A HREF=\"/V10080Aardv4rk*ch33se\">One Week</A></td>\n"
"</tr>\n"
"<tr>\n"
"<td><A HREF=\"/V1440Aardv4rk*ch33se\">One Day</A></td>\n"
"<td><A HREF=\"/V720Aardv4rk*ch33se\">Half Day</A></td>\n"
"<td><A HREF=\"/V360Aardv4rk*ch33se\">6 Hours</A></td>\n"
"<td><A HREF=\"/V180Aardv4rk*ch33se\">3 Hours</A></td>\n"
"</tr>\n"
"_EOF\n";

// prog_char changed to const char after Arduino IDE v 1.5.8 or so.
const char webtmpl[] PROGMEM = "<tr>\n"
"<td colspan=4 align=center><H4>_NAME</H4></td>\n"
"</tr>\n"
"<tr>\n"
"<td>_DATE</td><td>_TIME</td><td colspan=2>&nbsp;</td>\n"
"</tr>\n"
"<tr>\n"
"<td>Current Temp:</td><td>_CTMP&deg;F</td><td>Humidity</td><td>_CHUM RH</td>\n"
"</tr>\n"
"<tr>\n"
"<td>Current Status:</td><td colspan=2>_STATUS</td><td>&nbsp;</td>\n"
"</tr>\n"
"<tr>\n"
"<td colspan=4><hr></td>\n"
"</tr>\n"
"<tr>\n"
"<td>Settings:</td><td colspan=3>?SAVE</td>\n"
"</tr>\n"
"<tr>\n"
"<td>Temp:</td><td>_STMP&deg;F</td><td><A HREF=/st%d-->(-)</A></td><td><A HREF=/st%d++>(+)</A></td>\n"
"</tr>\n"
"<tr>\n"
"<td>Mode:</td><td>_MODE</td><td>?MODE</td><td>&nbsp;</td>\n"
"</tr>\n"
"<tr>\n"
"<td>Hysteresis:</td><td>_HYST</td><td colspan=2>&nbsp;</td>\n"
"</tr>\n"
"<tr>\n"
"<td>Auto/man:</td><td>_AUMA</td><td colspan=2>?AUMA</td>\n"
"</tr>\n"
"<tr>\n"
"<td colspan=4><hr></td>\n"
"</tr>\n"
"<tr>\n"
"<td>set point 1:</td>\n"
"<td>_SPTEMP0&deg;F</td>\n"
"<td colspan=2>at _SPTIME0</td>\n"
"</tr>\n"
"<tr>\n"
"<td>_SPACTV0</td>\n"
"<td><A HREF=/sp0%d-->(T--)</A> <A HREF=/sp0%d++>(T++)</A></td>\n"
"<td colspan=2><A HREF=/sh0%d-->(H--)</A> <A HREF=/sh0%d++>(H++)</A> <A HREF=/sm0%d-->(M--)</A> <A HREF=/sm0%d++>(M++)</A></td>\n"
"</tr>\n"
"<tr>\n"
"<td>set point 2:</td>\n"
"<td>_SPTEMP1&deg;F</td>\n"
"<td colspan=2>at _SPTIME1</td>\n"
"</tr>\n"
"<tr>\n"
"<td>_SPACTV1</td>\n"
"<td><A HREF=/sp1%d-->(T--)</A> <A HREF=/sp1%d++>(T++)</A></td>\n"
"<td colspan=2><A HREF=/sh1%d-->(H--)</A> <A HREF=/sh1%d++>(H++)</A> <A HREF=/sm1%d-->(M--)</A> <A HREF=/sm1%d++>(M++)</A></td>\n"
"</tr>\n"
"<tr>\n"
"<td>set point 3:</td>\n"
"<td>_SPTEMP2&deg;F</td>\n"
"<td colspan=2>at _SPTIME2</td>\n"
"</tr>\n"
"<tr>\n"
"<td>_SPACTV2</td>\n"
"<td><A HREF=/sp2%d-->(T--)</A> <A HREF=/sp2%d++>(T++)</A></td>\n"
"<td colspan=2><A HREF=/sh2%d-->(H--)</A> <A HREF=/sh2%d++>(H++)</A> <A HREF=/sm2%d-->(M--)</A> <A HREF=/sm2%d++>(M++)</A></td>\n"
"</tr>\n"
"<tr>\n"
"<td>set point 4:</td>\n"
"<td>_SPTEMP3&deg;F</td>\n"
"<td colspan=2>at _SPTIME3</td>\n"
"</tr>\n"
"<tr>\n"
"<td>_SPACTV3</td>\n"
"<td><A HREF=/sp3%d-->(T--)</A> <A HREF=/sp3%d++>(T++)</A></td>\n"
"<td colspan=2><A HREF=/sh3%d-->(H--)</A> <A HREF=/sh3%d++>(H++)</A> <A HREF=/sm3%d-->(M--)</A> <A HREF=/sm3%d++>(M++)</A></td>\n"
"</tr>\n"
"<tr>\n"
"<td colspan=4><hr></td>\n"
"</tr>\n"
"<tr>\n"
"<td>Backlight:</td> <td><A HREF=/bl%d-->(dim)</A>\n"
"<A HREF=/bl%d++>(bright)</A></td><td><A HREF=/bd%d-->(dim--)</A>\n"
"<A HREF=/bd%d++>(dim++)</A></td><td>&nbsp</td>\n"
"</tr>\n"
"_EOF\n";

// read a newline terminated line from the web template
PGM_P read_template_line (char *dbuf, PGM_P s) {
char c;
    *dbuf = '\0';
    while (c = pgm_read_byte(s)) {
	if(c == '\0') {
	    *dbuf++ = '\0';
	    return NULL;
	}      // leave pointing to '\0'
	else if(c == '\n') {
	    *dbuf++ = c;
	    *dbuf++ = '\0';
	    s++;         // point to next line or '\0'
	    break;
	}
	else {
	    *dbuf++ = c;
	    s++;
	}
    }
    return(s);
}

void show_template (EthernetClient eClient, unsigned char zone) {
PGM_P ptmpl;
char *p, *d;
unsigned char sp;
    time_t tNow = timelocal(now());
    ptmpl = (zone < 100) ? webtmpl : vactmpl ;
    do {
	ptmpl = read_template_line (Dbuf, ptmpl);
//	if(zone >= 100) {
//	    Serial.println(Dbuf);
//	}
	for(p = Dbuf, d = Dbuf3; *p ; ) {
	    if(*p == '?') {
		*d = '\0';
		if(!strncmp_P(p, PSTR("?SAVE"), 5)) {
		    strcpy_P(d, state_saved[zone] ? PSTR("&nbsp;") : PSTR("<A HREF=/save>save</A>"));
		    d = Dbuf3 + strlen(Dbuf3);
		    p += 5;
		}
		else if(!strncmp_P(p, PSTR("?AUMA"), 5)) {
		    strcpy_P(Dbuf2, zone_config[zone].auto_man == 'a' ? PSTR("<A HREF=/man%d>(Manual)</A>") : PSTR("<A HREF=/auto%d>(Automatic)</A>"));
		    sprintf(d, Dbuf2, zone);
		    d = Dbuf3 + strlen(Dbuf3);
		    p += 5;
		}
		else if(!strncmp_P(p, PSTR("?MODE"), 5)) {
		    strcpy_P(Dbuf2, zone_config[zone].modeSetting==HEATING ? PSTR("<A HREF=/off%d>(Off)</A>") : PSTR("<A HREF=/heat%d>(Heat)</A>"));
		    sprintf(d, Dbuf2, zone);
		    d = Dbuf3 + strlen(Dbuf3);
		    p += 5;
		}
		else {
		    *d++ = *p++;
		}
	    }
	    else if(*p == '_') {
		*d = '\0';
		if(!strncmp_P(p, PSTR("_EOF"), 4)) {
		    ptmpl = NULL;
		    return;
		}
		else if(!strncmp_P(p, PSTR("_NAME"), 5)) {
                    strcat_P(d, zone == 0 ? PSTR("Living Room") : (zone == 1) ? PSTR("Kitchen") : PSTR("Bedroom"));
		    d = Dbuf3 + strlen(Dbuf3);
		    p += 5;
		}
		else if(!strncmp_P(p, PSTR("_STATUS"), 7)) {
                    strcat(d, Status[zone]);
		    d = Dbuf3 + strlen(Dbuf3);
		    p += 7;
		}
		else if(!strncmp_P(p, PSTR("_VTIME"), 6)) {
		    strcpy_P(Dbuf2,PSTR("%lu"));
		    sprintf(d, Dbuf2, min_Timers[VACATION_TIMER]);
		    d = Dbuf3 + strlen(Dbuf3);
		    p += 6;
		}
		else if(!strncmp_P(p, PSTR("_AUMA"), 5)) {
		    strcpy_P(d, zone_config[zone].auto_man == 'a' ? PSTR("Automatic") : PSTR("Manual"));
		    d = Dbuf3 + strlen(Dbuf3);
		    p += 5;
		}
		else if(!strncmp_P(p, PSTR("_MODE"), 5)) {
		    strcpy_P(d, zone_config[zone].modeSetting==HEATING ? PSTR("Heating") : PSTR("Off"));
		    d = Dbuf3 + strlen(Dbuf3);
		    p += 5;
		}
		else if(!strncmp_P(p, PSTR("_TIME"), 5)) {
		    strcpy_P(Dbuf2,PSTR("%02d/%02d/%4d"));
		    sprintf(d, Dbuf2 ,month(tNow),day(tNow),year(tNow));
		    d += 10;
		    *d = '\0';
		    p += 5;
		}
		else if(!strncmp_P(p, PSTR("_DATE"), 5)) {
		    strcpy_P(Dbuf2,PSTR("%02d:%02d:%02d"));
		    sprintf(d, Dbuf2 ,hour(tNow),minute(tNow),second(tNow));
		    d += 8;
		    *d = '\0';
		    p += 5;
		}
		else if(!strncmp_P(p, PSTR("_CTMP"), 5)) {
		    sprintf(d, "%2d", Fvalue[zone]);
		    d += 2;
		    *d = '\0';
		    p += 5;
		}
		else if(!strncmp_P(p, PSTR("_CHUM"), 5)) {
		    sprintf(d, "%2d%%", Hvalue[zone]);
		    d += 3;
		    *d = '\0';
		    p += 5;
		}
		else if(!strncmp_P(p, PSTR("_HYST"), 5)) {
		    sprintf(d, "%2d", zone_config[zone].Hysteresis);
		    d += 2;
		    *d = '\0';
		    p += 5;
		}
		else if(!strncmp_P(p, PSTR("_STMP"), 5)) {
		    sprintf(d, "%2d", zone_config[zone].tempSetting);
		    d += 2;
		    *d = '\0';
		    p += 5;
		}
		else if(!strncmp_P(p, PSTR("_SPACTV"), 7)) {
		    sp = p[7] - '0' ;
		    if(zone_config[zone].setpoint[sp].active) {
			strcpy_P(d, PSTR("On <A HREF=/spof"));
			char *dp = d + strlen(d);
			*dp++ = '0' + sp;
			*dp++ = '0' + zone;
			*dp = '\0';
			strcat_P(d, PSTR(">(-&gt; Off)</A>")) ;
		    }
		    else {
			strcpy_P(d, PSTR("Off <A HREF=/spon"));
			char *dp = d + strlen(d);
			*dp++ = '0' + sp;
			*dp++ = '0' + zone;
			*dp = '\0';
			strcat_P(d, PSTR(">(-&gt; On)</A>")) ;
		    }
		    p += 8;
		    d = Dbuf3 + strlen(Dbuf3);
		}
		else if(!strncmp_P(p, PSTR("_SPTIME"), 7)) {
		    sp = p[7] - '0' ;
		    sprintf(d, "%2d:%02d", zone_config[zone].setpoint[sp].hour, zone_config[zone].setpoint[sp].minute);
		    d += 5;
		    *d = '\0';
		    p += 8;
		}
		else if(!strncmp_P(p, PSTR("_SPTEMP"), 7)) {
		    sp = p[7] - '0' ;
		    sprintf(d, "%2d", zone_config[zone].setpoint[sp].temp);
		    d += 2;
		    *d = '\0';
		    p += 8;
		}
		else {
		    *d++ = *p++;
		}
	    }
	    else if(*p == '%') {
		if(*++p == 'd') {
		    sprintf(d, "%d", zone);
		    d++;
		    *d = '\0';
		    p++;
		}
		else {
		    *d++ = *p++;
		}
	    }
	    else if(*p == '\n') {
		*d++ = *p++;
		*p = '\0';
		*d = '\0';
		break;
	    }
	    else {
		*d++ = *p++;
	    }
	}
#define DEBUG_TMPL 0
#if DEBUG_TMPL
	Serial.print(Dbuf);
	Serial.println("^^^___dbuf");
	Serial.print(Dbuf3);
	Serial.println("^^^___dbuf3");
#endif
	eClient.print(Dbuf3);
    } while(Dbuf[0] && ptmpl);
}

// default or root level request, show status
void show_web_page (EthernetClient eClient) {
byte tm1, tp1;
unsigned char zone;
    // if (strstr_P(Dbuf2, PSTR("GET / ")) != 0)
    // standard http response header
    strcpy_P(Dbuf, PSTR("<html><head><title>Thermostat</title></head><body><table>"));
    eClient.print(Dbuf);
    // show vacation time (status) and form to set vacation mode
    show_template(eClient, 110);
    for(zone = 0; zone < MAXZONES ; zone++) {
	if(!SensorUnplugged[zone]) {
	    show_template(eClient, zone);
	}
    }
    strcpy_P(Dbuf, PSTR("</table></body></html>"));
    eClient.println(Dbuf);
}
